include "Vram.inc"

ext InitVram_, InitSound_, TempoValue
ext SoundHandler
ext InitSprites_

    dseg
TimerCount: defb 0 public TimerCount
NmiEnabled: defb 0 public NmiEnabled

cseg
DisableNmi: public DisableNmi
    push af
        xor a
        ld (NmiEnabled),a
    pop af
ret

EnableNmi: public EnableNmi
    push af
        ld a,0ffh
        ld (NmiEnabled),a
        ; ld a,(VdpAddress+1)
    pop af
    call Handler
ret


cseg
Init_: public Init_
    call InitSound_
    call EnableNmi
    call InitVram_
    call InitSprites_
ret


Handler: public Handler
    push af
        ld a,(NmiEnabled)
        or a
        if nz
            in a,(VdpPort+1)
            and 80h
            if nz
                push hl
                    ld hl,TimerCount
                    inc (hl)
                pop hl
                call SoundHandler
            endif
        endif
    pop af
; ei
retn


WaitTimer_: public WaitTimer_
    push af | push de
        ld e,a
        do
            ld a,(TimerCount)
            cp e
        while c | wend
        di
            xor a
            ld (TimerCount),a
        ei
    pop de | pop af
ret
