include "Vram.inc"
include "Chars.inc"

ext LDIRVM
ext DisableNmi, EnableNmi
ext SpritePattern
ext TopY_, dotOffset_

SpriteCount equ 15

BufferUnitSize equ 4
Offset_y equ 0
Offset_x equ 1
Offset_name equ 2
Offset_color equ 3

Movable_x equ 0
Movable_y equ 1
Movable_xd equ 2
Movable_yd equ 3
Movable_sprite equ 4


    dseg
Sprites_:   public Sprites_
Buffer:
    defs BufferUnitSize * SpriteCount
FirstIndex:
    defs 1
FirstAddress:
    defs 2

; void InitSprites();
cseg
InitSprites_: public InitSprites_
	push	af
	push	hl
	push	de
	push	bc
        ld hl,SpritePattern
        ld de,Vram_SpriteGenerator
        ld bc,CharHeight*PatternCount
        call LDIRVM

        ld hl,Buffer
        ld de,BufferUnitSize
        ld b,SpriteCount
        do 
            ld (hl),192
            add hl,de
        dwnz
        xor a
        ld (FirstIndex),a
        ld hl,Buffer
        ld (FirstAddress),hl
    pop	bc
	pop	de
	pop	hl
	pop	af
ret

cseg
ShowSprite_: public ShowSprite_
	push af | push hl | push de
        push de
            ld l,(ix+Movable_sprite)
            ld h,0
            add hl,hl   ;*2
            add hl,hl   ;*4
            ld de,Buffer
            add hl,de
        pop de
        ld a,(TopY_)
        ld d,a
        ld a,(dotOffset_)
        ld b,a
        ; ld a,8
        ; sub b
        ; and 7
        ; ld b,a
        ; di
        call DisableNmi
            ld a,(ix+Movable_y)
            sub d
            cp WindowHeight
            if c
                add a,2
                add a,a ;*2
                add a,a ;*4
                add a,a ;*8
                add a,(ix+Movable_yd)
                add a,b
                dec a
            else
                ld a,192
            endif
            ld (hl),a
            inc hl
            ld a,(ix+Movable_x)
            add a,a ;*2
            add a,a ;*4
            add a,a ;*8
            add a,(ix+Movable_xd)
            ld (hl),a
            inc hl 
            ld (hl),e ; pattern
            inc hl 
            ld (hl),c ; color
        ; ei
        call EnableNmi
	pop	de | pop hl | pop af
ret


HideSprite_:
    public HideSprite_
	push	af
	push	hl
	push	de
            ld l,a  ; index
            ld h,0
            add hl,hl   ;*2
            add hl,hl   ;*4
            ld de,Buffer
            add hl,de
            ; di
            call DisableNmi
                ld (hl),192
            ; ei
            call EnableNmi
    pop	de
	pop	hl
	pop	af
ret


HideAllSprites_:
    public HideAllSprites_
	push	hl
	push	bc
        ld hl,Buffer
        ld b,SpriteCount
        ; di
        call DisableNmi
            do
                ld (hl),192
                inc hl
                inc hl
                inc hl
                inc hl
            dwnz
        ; ei
        call EnableNmi
    pop	bc
	pop	hl
    call UpdateSprites_
ret


UpdateSprites_:
    public UpdateSprites_
    push af | push hl | push de | push bc
        ld c,VdpPort
        ld hl,VRAM_SpriteAttribute or 4000h
        ; di
        call DisableNmi
            inc c
            out (c),l
            out (c),h
            dec c
            
            ld a,(FirstIndex)
            ld hl,(FirstAddress)
            ld d,SpriteCount
            do
                ld b,BufferUnitSize
                do
                    ld e,(hl)
                    inc hl
                    out (c),e
                dwnz
                inc a
                cp SpriteCount
                if nc
                    xor a
                    ld hl,Buffer
                endif
                dec d
            while nz | wend
        ; ei
        call EnableNmi
        inc hl
        inc hl
        inc hl
        inc hl
        inc a
        cp SpriteCount
        if nc
            xor a
            ld hl,Buffer
        endif
        ld (FirstIndex),a
        ld (FirstAddress),hl
    pop bc | pop de | pop hl | pop af
ret
